//RemplPolices_fichier_205f.js
// 17.11.14 / Hans Hsler, Chtelard 52, CH-1018 Lausanne / E-mail: hsa@ringier.ch
//DESCRIPTION:Remplacer les polices du document actif.

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// vrifier la version du programme
var appVers = app.version[0];
if (appVers != 4) {
	alert ("Il ne faut utiliser ce script qu'avec InDesign CS2.", "Stop");
	exit();
}

var oneDoc = true;
var selFolder = Folder ("Tiger/Users/Documents/");

// vrifier s'il y a un document ouvert
if (app.documents.length == 0) {
	oneDoc = false;
	// montrer le dialogue pour slectionner un dossier
	var sourceFolder = Folder.selectDialog("Slectionner le dossier contenant les fichiers InDesign", selFolder);
	if (sourceFolder != null) {
		// essayer de trouver le fichier texte
		var fileList = Folder(sourceFolder).getFiles("*.txt");
		if (fileList.length == 0) {
			alert ("Le dossier ne contient pas de fichier texte.", "Un problme");
			exit();
		}
		var f = fileList[0];
	}
	else {
		exit();
	}
}
else {
// demander  l'utilisateur de slectionner un fichier
	var f = File(selFolder).openDlg("Slectionner le fichier contenant les noms des polices", "Text Files:*.txt");
	if (f == null) {
		exit();
	}
}

// tenter de lire le fichier
var fontsString = "";
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		fontsString = f.read();
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}

// tester les caractres sparateur 
var nameSep = "";
var paraSep = "";
var pairSep = "";
if (fontsString.indexOf("\t") != -1) {
	nameSep = "tab";
}
if (fontsString.indexOf("\r\n") != -1) {
	paraSep = "\r\n";
}
else if (fontsString.indexOf("\r") != -1) {
	paraSep = "\r";
}
else if (fontsString.indexOf("\n") != -1) {
	paraSep = "\n";
}
if (fontsString.indexOf("=") != -1) {
	pairSep = "=";
}
if (nameSep == "") {
	alert ("Le fichier slectionn ne contient pas de tabulateur\n(entre famille et style).", "Stop");
	exit();
}
if (pairSep == "") {
	alert ("Le fichier slectionn ne contient pas de signe gal\n(entre anciens et nouveaux noms).", "Stop");
	exit();
}
if (paraSep == "") {
	alert ("Le fichier slectionn\nne contient pas de signes retour.", "Stop");
	exit();
}

// convertir la chane de texte des noms de polices en liste
try {
	fontsList = fontsString.split(paraSep);
}
catch (e) {
}

// appeler la fonction quand il y a un document ouvert
var probCtr = 0;
if (oneDoc) {
	replaceFonts();
}
// sinon, lister les documents InDesign et les trater  tour de rle
else {
	var docList = Folder(sourceFolder).getFiles("*.indd");
	var nDocs = docList.length;
	if (nDocs == 0) {
		alert ("Le dossier slectionn ne contient pas de documents InDesign.", "Attention");
		exit();
	}
	// dsactiver l'affichage de dialogue (il peut y avoir des images et des polices manquantes)
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
	var docVers;
	for (var d=0; d<nDocs; d++) {
		docVers = testVers(docList, d);
		if (docVers > 0 && docVers <= appVers) {
			try {
				app.open(File(docList[d]));
				replaceFonts();
				try {
					app.activeDocument.save();
				}
				catch (e) {
				}
				app.activeDocument.close();
			}
			catch (e) {
				probCtr++;
			}
		}
		else {
			probCtr++;
		}
	}
}

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// annoncer la fin de l'action
if (probCtr == 0) {
	alert ("Termin.", " ");
}
else if (probCtr == 1) {
	alert ("Un document n'a pas pu tre trat.", "Attention");
}
else {
	alert ("Le nombre de documents non trats: " + probCtr, "Attention");
}


///////////////////////////////////////////////////////////////////////////////
// les deux fonctions
///////////////////////////////////////////////////////////////////////////////

function testVers(docList, d) {
	// tenter de lire le premier bout du fichier InDesign
	var t = docList[d];
	var testString = "";
	var fileIsOpen = t.open("r");
	if (fileIsOpen) {
		try {
			testString = t.read(40);
			t.close();
		}
		catch (e) {
			try {
				t.close();
			}
			catch (e) {
			}
		}
	}
	if (testString !="") {
		try {
			var pfID = testString.charCodeAt(24);
			if (pfID == 2) { // = Mac
				return testString.charCodeAt(32);
			}
			else if (pfID == 1) {  // = Win
				return testString.charCodeAt(29);
			}
			else {
				var docVers = 0;
			}
		}
		catch (e) {
			return 0;
		}
	}
	else {
		return 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
	// Remplacer les polices des textes et des styles
///////////////////////////////////////////////////////////////////////////////

function replaceFonts() {
	// une rfrence au document au premier plan
	var curDoc = app.documents[0];
	
	// mettre le point zro  zro/zro
	curDoc.zeroPoint = [0,0];
	
	// mettre l'origine des rgles  "Page"
	rO = curDoc.viewPreferences.rulerOrigin;
	if (rO != 1380143215) {
		curDoc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;
	}
	
	// mmoriser la dimension de la premire page
	var pSz = curDoc.pages[0].bounds;
	
	// prparer les rglages par dfaut des styles
	try {
		var eaParaStyle = curDoc.paragraphStyles.item(1);
		var noCharStyle = curDoc.characterStyles.item(0);
		curDoc.textDefaults.appliedParagraphStyle = eaParaStyle;
		curDoc.textDefaults.appliedCharacterStyle = noCharStyle;
	}
	catch (e) {
	}
	
	// dfinir une rfrence  la nuance "Papier"
	var whiteColor = curDoc.swatches.itemByName("Paper");
	
	// tester le verrouillage du calque actif
	var curLayer = app.activeWindow.activeLayer;
	var layerLocked = curLayer.locked;
	if (layerLocked) {
		curLayer.locked = false;
	}
	
	// supprimer le bloc contenant les noms des styles de paragraphe (s'il existe)
	try {
		curDoc.textFrames.itemByName("paraStyles").remove();
	}
	catch (e) {
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des textes
	var allStories = curDoc.stories;
	var curFont;
	var curNew;
	var curOld;
	var curPair;
	var nFonts = fontsList.length;
	var nStories = allStories.length;
	var nTsr;
	var tsr;
	var tsrFonts;
	
	for (var i=0; i<nStories; i++) {
		tsr = allStories[i].textStyleRanges;
		nTsr = tsr.length;
		tsrFonts = tsr.everyItem().appliedFont;
		for (var j=nTsr-1; j>-1; j--) {
			try {
				curFont = tsrFonts[j].name;
				for (var k=0; k<nFonts; k++) {
					curPair = fontsList[k];
					curOld = curPair.split("=")[0];
					if (curFont == curOld) {
						curNew = curPair.split("=")[1];
						if (curNew != "") {
							try {
								tsr[j].appliedFont = curNew;
							}
							catch (e) {
							}
							break;
						}
					}
				}
			}
			catch (e) {
			}
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des styles de paragraphes
	
	// crer un bloc texte, le nommer et appliquer la couleur du fond
	var paraFrame = app.activeWindow.activePage.textFrames.add({geometricBounds:[pSz[0],pSz[1],pSz[2],pSz[3]], 
		label:"paraStyles", fillColor:whiteColor});
	var firstPara = paraFrame.parentStory.contents = curDoc.paragraphStyles[1].name + "\r";
	firstPara.appliedParagraphStyle = curDoc.paragraphStyles[1];
	
	// dresser la liste des styles de paragraphes
	var allParaStyles = curDoc.paragraphStyles;
	var paraCount = allParaStyles.length;
	
	var paraStory = paraFrame.parentStory;
	var paraStyle;
	// une boucle  travers la liste. Le compteur commence  "2" (au lieu de "0"), 
	// afin de laisser de cte "[Aucun style de paragraphe]" (n'est pas accessible par script) 
	// et le "Paragraphe standard" est dj pris en charge
	// mais les paragraphes doivent tre adresss par  '(i-1)'
	for (var i=2; i<paraCount; i++) {
		paraStyle = allParaStyles[i].name;
		// insrer le nom actuel
		paraStory.insertionPoints[-1].contents = paraStyle + "\r";
		try {
			// appliquer le style correspondant  l ligne actuelle
			paraStory.paragraphs[(i-1)].appliedParagraphStyle = paraStyle;
		}
		catch (e) {
		}
	}	
	
	// mettre le contenu du bloc des noms des styles de paragraphes
	// dans la variable 'paraStory' et convertir cette chane dans une liste
	try {
		var paraStory = curDoc.textFrames.itemByName("paraStyles").parentStory;
		var paraString = paraStory.contents;
		var paraList = paraString.split("\r");
		var nParas = paraList.length;
	}
	catch (e) {
		alert ("Le bloc contenant les chantillons des styles\nde paragraphes est introuvable.", "Stop");
		app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
		exit();
	}
	
	var ctr = 0;
	var curStyle;
	
	// une boucle traversant la liste
	for (var i=0; i<nParas-1; i++) {
		curStyle = curDoc.paragraphStyles.itemByName(paraList[i]);
		try {
			curFont = paraStory.paragraphs[i].characters[2].appliedFont.name;
			for (var j=0; j<nFonts; j++) {
				curPair = fontsList[j];
				curOld = curPair.split("=")[0];
				if (curFont == curOld) {
					curNew = curPair.split("=")[1];
					if (curNew != "") {
						try {
							curStyle.appliedFont = curNew;
						}
						catch (e) {
						}
					}
					break;
				}
			}
		}
		catch (e) {
		}
	}
		
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des styles de caractres
	var charStyles = curDoc.characterStyles;
	var curF;
	var curS;
	var nCharStyles = charStyles.length;
	
	for (var i=1; i<nCharStyles; i++) {
		try {
			curStyle = charStyles[i];
			curF = curStyle.appliedFont;
			curS = curStyle.fontStyle;
			if (curS != 1851876449) {
				curFont = curF + "\t" + curS;
				for (var j=0; j<nFonts; j++) {
					curPair = fontsList[j];
					curOld = curPair.split("=")[0];
					if (curFont == curOld) {
						try {
							curNew = curPair.split("=")[1];
							if (curNew != "") {
								curStyle.appliedFont = curNew;
							}
						}
						catch (e) {
						}
						break;
					}
				}
			}
			else {
				curFont = curF;
				for (var j=0; j<nFonts; j++) {
					curPair = fontsList[j];
					curOld = curPair.split("=")[0];
					curFam = curOld.split("\t")[0];
					if (curFont == curFam) {
						try {
							curNew = curPair.split("=")[1];
							newFam = curNew.split("\t")[0];
							if (curNew != "") {
								curStyle.appliedFont = newFam;
							}
						}
						catch (e) {
						}
						break;
					}
				}
			}
		}
		catch (e) {
		}
	}
	
	//=================================================================
	// Mettre de l'ordre
	//=================================================================
	
	// supprimer le bloc contenant les chantillons des styles de paragraphes
	try {
		curDoc.textFrames.itemByName("paraStyles").remove();
	}
	catch (e) {
	}
	
	// restaurer l'origine des rgles
	if (rO != 1380143215) {
		try {
			curDoc.viewPreferences.rulerOrigin = rO;
		}
		catch (e) {
		}
	}
	
	// rtablir un verrouillage du calque actif
	if (layerLocked) {
		curLayer.locked = true;
	}
}